!  Irr_Supply.f90 
!
!  FUNCTIONS:
!  Irr_Supply - Entry point of console application.
!

!****************************************************************************
!
!  PROGRAM: Irr_Supply
!
!  PURPOSE:  Entry point for the console application.
!
!****************************************************************************
MODULE PARAM
    
    DATA MasterDIR /'W:\COHYST\COHYST\Run028\Run028b2\Inputs\'/
    DATA MasterFile /'MasterInput_v27.1.txt'/

    CHARACTER*12, ALLOCATABLE ::    Crops(:)
    
    CHARACTER*1000  INDIR, OUTDIR, WBPDIR, LUDIR, CNLDIR, MasterDIR
    CHARACTER*1000  MISCDIR, MIDIR
    CHARACTER*250   GWLUfld, SWLUfld, COLUfld, DryLUfld, GWCfld
    CHARACTER*250   GWLU, SWLU, COLU, DryLU, cRun, MODname
    CHARACTER*250   CellLoc, Coeffile, AEfile, ROZfile, GWCfile, MasterFile
    CHARACTER*250   PctRchfile, SWidxfile, CountID, Cell_county
    CHARACTER*250   cnlmastfile, miscrmastfile, miscpmastfile, mirmastfile, mipmastfile
    CHARACTER*250   ActCellFile
    !Added 1/7/2016
    CHARACTER*250   Callyrfile
    
    INTEGER     ncells, nczones, nrzones, nsoils, nirrdist, ncrops
    INTEGER     startyr, endyr, DPonly, SWonly
    INTEGER     ncols, nrows, cnlrflg, miscrflg, miscpflg, mirflg, mipflg
    INTEGER     Rch0flg
    !Added 1/7/2016
    INTEGER     ctrlyrs
    
    REAL    csize
    
    CHARACTER*4     YRT
    CHARACTER*3     Mon(0 : 12)
    !Added 1/7/2016
    CHARACTER*4     YRTlu, YRTwbp, YRTgwc
    
    INTEGER     sidx(56), roz, irrdist
    INTEGER     i, cell, z, s, c, icrop
    INTEGER     ii, jj, kk, j, pflag, zone
    INTEGER     iyear, indx, swdist, yr, swidx
    
    REAL    annval, monval(12)
    REAL    Dummy, ADJETdry, ADJetirr, Fslgw, Fslsw, DryET2RO
    REAL    ADJdp, ADJro, ROmax, ROmin, DPLL, DPcap, ROfDP
    REAL    M2G, totacs
    REAL    GWPcell(12), SWDcell(12), COPcell(12), CODcell(12)
    REAL    NIR(12), CODnet(12)
    REAL    SWDa, GWPa, COPa, CODa
    REAL    wt(12), value1
    
    DOUBLE PRECISION    ANNID(4)
    
    INTEGER, ALLOCATABLE :: Soil(:), Coefz(:)
    !Added 1/7/2016
    INTEGER, ALLOCATABLE :: LUyear(:), WBPyear(:), GWCyear(:)
    INTEGER, Allocatable :: yrctrl(:)    
    
    REAL, ALLOCATABLE :: AEgyr(:,:), AEsyr(:,:)
    REAL, ALLOCATABLE :: SWDsup(:,:,:), distwt(:,:)
    REAL, ALLOCATABLE :: ADJNIR(:,:,:), GWC(:), LatLoss(:)
    REAL, ALLOCATABLE :: SWac(:), COac(:), GWac(:)
    REAL, ALLOCATABLE :: Precip(:, :) 
    REAL, ALLOCATABLE :: GWP(:,:), SWD(:,:), COP1(:,:), COP2(:,:), COD(:,:)
    REAL, ALLOCATABLE :: NIRCS(:,:,:)
    REAL, ALLOCATABLE :: AEgwb(:,:), AEswb(:,:), AEgw(:), AEsw(:)
    
    DATA Mon /'Ann', 'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'/
    
    REAL Isaac(12)
    
END MODULE PARAM
!****************************************************************************
PROGRAM Irr_Supply
    USE PARAM
    IMPLICIT NONE
    
    Dummy = 0.

    OPEN (1, FILE = TRIM(MasterDIR)//TRIM(MasterFile), STATUS = 'OLD')
    READ (1, *)

    READ (1, *) cRun
    READ (1, *) MODname
    READ (1, *) INDIR
    READ (1, *) OUTDIR
    READ (1, *) WBPDIR
    READ (1, *) LUDIR
    READ (1, *) CNLDIR
    READ (1, *) MiscDIR
    READ (1, *) MIDIR
    READ (1, *) GWLUfld
    READ (1, *) SWLUfld
    READ (1, *) COLUfld
    READ (1, *) DryLUfld
    READ (1, *) GWLU
    READ (1, *) SWLU
    READ (1, *) COLU
    READ (1, *) DryLU
    READ (1, *) GWCfld
    READ (1, *) GWCfile
    READ (1, *) CellLoc
    READ (1, *) Coeffile
    READ (1, *) AEfile
    READ (1, *) ROZfile
    READ (1, *) PctRchfile
    READ (1, *) SWidxfile
    READ (1, *) CountID
    READ (1, *) Cell_county
    READ (1, *) CNLmastfile
    READ (1, *) MISCrmastfile
    READ (1, *) MISCpmastfile
    READ (1, *) MIrmastfile
    READ (1, *) MIpmastfile
    READ (1, *) ActCellfile
    !Added 1/7/2016
    READ (1, *) CallYrfile  
    READ (1, *) ncells
    READ (1, *) startyr
    READ (1, *) endyr
    READ (1, *) RCH0flg
    READ (1, *) DPonly
    READ (1, *) SWonly
    READ (1, *) cnlrflg
    READ (1, *) miscrflg
    READ (1, *) miscpflg
    READ (1, *) MIrflg
    READ (1, *) MIpflg
    !Added 1/7/2016
    READ (1, *) ctrlyrs
    READ (1, *) nczones
    READ (1, *) nrzones
    READ (1, *) nsoils
    READ (1, *) nirrdist
    READ (1, *) csize
    READ (1, *) ncols
    READ (1, *) nrows
    READ (1, *) ncrops
    
    ALLOCATE (Crops(ncrops))
    
    DO i = 1, ncrops
        READ (1, *) crops(i)
    END DO
    CLOSE (1)
    
    OUTDIR = TRIM(OUTDIR)//TRIM(cRun)//'\Results\'
    
    ALLOCATE (Soil(ncells), Coefz(ncells))
    ALLOCATE (AEgyr(nczones, 2), AEsyr(nczones, 2), AEgwb(nczones, 2), AEswb(nczones, 2), AEgw(nczones), AEsw(nczones))
    ALLOCATE (SWDsup(startyr : endyr, nirrdist, 12), NIRCS(ncells, ncrops - 2, 0 : 12))
    ALLOCATE (GWP(ncrops, 12), SWD(ncrops, 12), COP1(ncrops, 12), COP2(ncrops, 12), COD(ncrops, 12))
    ALLOCATE (Precip(ncells, 0 : 12))
    ALLOCATE (GWC(nirrdist), LatLoss(nirrdist))
    ALLOCATE (ADJnir(nczones, ncrops, nsoils))
    ALLOCATE (GWac(ncrops), SWac(ncrops), COac(ncrops))
    ALLOCATE (distwt(nirrdist, 12))
    
    !Added 1/7/2016
    ALLOCATE (yrctrl(ctrlyrs))
    ALLOCATE (LUyear(startyr : endyr), WBPyear(startyr : endyr), GWCyear(startyr : endyr))
    
    !Populate cell soils, zones, and location
    WRITE (6, *) 'Reading Cell Location'
    OPEN (1, FILE = TRIM(INDIR)//TRIM(CellLoc), STATUS = 'OLD')
    READ (1, *)
    DO WHILE (.NOT. EOF(1))
        READ (1, *) cell, Soil(cell), CoefZ(cell), ROZ, M2G
    END DO
    CLOSE (1)
    
    !Load coefficient zone coefficients
    !z - zone
    !c - crop
    !s - soil
    WRITE (6, *) 'Reading Coefficient Zone Parameters'
    OPEN (1, FILE = TRIM(INDIR)//TRIM(Coeffile), STATUS = 'OLD')
    READ (1, *)
    DO WHILE (.NOT. EOF(1))
        READ (1, *) z, c, s, ADJnir(z, c, s), ADJetdry, ADJetirr, &
                        Fslgw, Fslsw, DryET2RO, &
                        ADJdp, ADJro, ROmax, ROmin, &
                        DPLL, DPcap, ROfDP
    END DO
    CLOSE (1)
    
    sidx = 0
    !Read SWIndex
    OPEN (1, FILE = TRIM(INDIR)//'SWindex2.txt', STATUS = 'OLD')
    READ (1, *)
    DO WHILE (.NOT. EOF(1))
        READ (1, *) indx, swdist
        sidx(swdist) = indx    
    END DO
    CLOSE (1)
    
    !Load application efficiencies
    WRITE (6, *) 'Loading Application Efficiencies'
    OPEN (1, FILE = TRIM(INDIR)//TRIM(AEfile), STATUS = 'OLD')
    READ (1, *)
    DO WHILE (.NOT. EOF(1))
        READ (1, *) zone, AEgwb(zone, :), AEgyr(zone, :), AEswb(zone, :), AEsyr(zone, :)
    END DO
    CLOSE (1)
    
    SWDsup = 0.
    OPEN (1, FILE = TRIM(OUTDIR)//'AppIrr\DistDel.txt', STATUS = 'OLD')
    READ (1, *)
    DO WHILE (.NOT. EOF(1))
        READ (1, *) yr, swidx, swdist, annval, monval
        IF (yr .LT. startyr) GOTO 1
        IF (yr .GT. endyr) GOTO 1
        SWDsup(yr, sidx(swdist), :) = monval
1   END DO
    CLOSE (1)
    
    !Read in Call year
    !Added 1/7/2016 to control the annual input data and allow the same data to be applied to different years
    !ex: applying a fixed land use to the historical climate
    OPEN (1, FILE = TRIM(INDIR)//TRIM(CallYrFile), STATUS = 'OLD')
    READ (1, *)
    DO WHILE (.NOT. EOF(1))
        READ (1, *) yr, yrctrl
        IF ((yr .GE. startyr) .AND. (yr .LE. endyr)) THEN
            LUyear(yr) = yrctrl(1)
            WBPyear(yr) = yrctrl(2)
            GWCyear(yr) = yrctrl(3)
        END IF
    END DO
    CLOSE (1)
    
    OPEN (30, FILE = TRIM(OUTDIR)//'AppIrr/Irrtrans.txt', STATUS = 'UNKNOWN')
    WRITE (30, 300)
    
    OPEN(40, FILE = TRIM(OUTDIR)//'Supply_sum.txt', STATUS = 'UNKNOWN')
    WRITE (40, 400)
    
    !Added 1/7/2016
    WRITE (6, 600) 
        
    DO iyear = startyr, endyr
        !Altered 1/7/2016
        WRITE (6, 601) iyear, LUyear(iyear), WBPyear(iyear), GWCyear(iyear)
        WRITE (YRT, '(I4)') iyear
        
        !Added 1/7/2016
        WRITE (YRTlu, '(I4)') LUyear(iyear)
        WRITE (YRTwbp, '(I4)') WBPyear(iyear)
        WRITE (YRTgwc, '(I4)') GWCyear(iyear)
        
        CALL CSFiles
        CALL GetAE
        
        GWC = 0.
        LatLoss = 0.
        !Load ground water concentration and lateral loss parameters
        OPEN (1, FILE = TRIM(INDIR)//TRIM(GWCfld)//'\'//TRIM(GWCfile)//Trim(YRTgwc)//'.txt', STATUS = 'OLD')
        READ (1, *) 
        DO WHILE (.NOT. EOF(1))
            READ (1, *) yr, irrdist, GWC(sidx(irrdist)), LatLoss(sidx(irrdist))
        END DO
        CLOSE (1)
        
        distwt = 0.
        OPEN (1, FILE = TRIM(LUDIR)//TRIM(SWLUfld)//'\'//TRIM(SWLU)//TRIM(YRTlu)//'.txt', STATUS = 'OLD')
        READ (1, *)
        DO WHILE (.NOT. EOF(1))
            READ (1, *) cell, yr, swdist, swidx, totacs, SWac
            
            DO j = 1, ncrops - 2
                IF (SWac(j) .GT. 0.) THEN
                    NIR = MAX(NIRCS(cell, j, 1 : 12), 0.)
                    distwt(swidx, :) = distwt(swidx, :) + NIR(1 : 12) * ADJnir(Coefz(cell), j, soil(cell)) / (12 * AEsw(Coefz(cell))) * SWac(j) * (1 + LatLoss(swidx))
                END IF
            END DO
            
        END DO
        CLOSE (1)
        
        OPEN (1, FILE = TRIM(LUDIR)//TRIM(COLUfld)//'\'//TRIM(COLU)//TRIM(YRTlu)//'.txt', STATUS = 'OLD')
        READ (1, *)
        DO WHILE (.NOT. EOF(1))
            READ (1, *) cell, yr, swdist, swidx, totacs, COac
            
            DO j = 1, ncrops - 2
                IF(COac(j) .GT. 0.) THEN
                    NIR = MAX(NIRCS(cell, j, 1 : 12), 0.)
                    distwt(swidx, :) = distwt(swidx, :) + NIR(1 : 12) * ADJnir(Coefz(cell), j, soil(cell)) / (12 * AEsw(Coefz(cell))) * COac(j) * (1 - GWC(swidx)) * (1 + LatLoss(swidx))
                END IF
            END DO
            
        END DO
        CLOSE (1)
        
        Precip = 0.
        OPEN (1, FILE = TRIM(WBPDIR)//'Precip\PRECIP'//TRIM(YRTwbp)//'.txt', STATUS = 'OLD')
        READ (1, *)
        DO WHILE (.NOT. EOF(1))
            READ (1, *) cell, yr, icrop, Precip(cell, 0 : 12)
            Precip(cell, 0) = SUM(Precip(cell, 1 : 12))
        END DO 
        CLOSE (1)
        
        AnnID = 0.
        
        OPEN (10, FILE = TRIM(OUTDIR)//'AppIrr/GWP/GWP'//TRIM(YRT)//'.txt', STATUS = 'UNKNOWN')
        OPEN (11, FILE = TRIM(OUTDIR)//'AppIrr/SWD/SWD'//TRIM(YRT)//'.txt', STATUS = 'UNKNOWN')
        OPEN (12, FILE = TRIM(OUTDIR)//'AppIrr/COD/COD'//TRIM(YRT)//'.txt', STATUS = 'UNKNOWN')
        OPEN (13, FILE = TRIM(OUTDIR)//'AppIrr/COP/COP'//TRIM(YRT)//'.txt', STATUS = 'UNKNOWN')
        OPEN (20, FILE = TRIM(OUTDIR)//'SWIDsum/SWISsum'//TRIM(YRT)//'.txt', STATUS = 'UNKNOWN')
        
        WRITE (10, 100) (Mon(i), i = 0, 12)
        WRITE (11, 101) (Mon(i), i = 0, 12)
        WRITE (12, 103) (Mon(i), i = 0, 12)
        WRITE (13, 102) (Mon(i), i = 0, 12)
        WRITE (20, 200)
        
        ii = 0
        pflag = 2
        !GW Loop
        OPEN (1, FILE = TRIM(LUDIR)//TRIM(GWLUfld)//'\'//TRIM(GWLU)//TRIM(YRTlu)//'.txt', STATUS = 'OLD')
        READ (1, *)
        DO WHILE (.NOT. EOF(1))
            READ (1, *) cell, yr, totacs, GWac
            GWPcell = 0.
            GWP = 0.
            
            DO j = 1, ncrops - 2
                IF (GWac(j) .GT. 0.) THEN
                    NIR = MAX(NIRCS(cell, j, 1 : 12), 0.)
                
                    GWP(j, :) = NIR(1 : 12) * ADJnir(CoefZ(cell), j, soil(cell)) / (12 * AEgw(Coefz(cell))) * GWac(j)
                    GWPa = SUM(GWP(j, 1 : 12))
                    GWPcell(1 : 12) = GWPcell(1 : 12) + GWP(j, 1 : 12)
                    
                    ii = ii + 1
                    WRITE (10, 110) ii, Cell, iyear, j, GWPa, GWP(j, :)
                END IF
            END DO
            
            AnnID(pflag - 1) = AnnID(pflag - 1) + SUM(GWPcell(1 : 12)) 
            
        END DO
        CLOSE (1)
        CLOSE (10)
        
        
        jj = 0
        pflag = 3
        !SW Loop
        OPEN (1, FILE = TRIM(LUDIR)//TRIM(SWLUfld)//'\'//TRIM(SWLU)//TRIM(YRTlu)//'.txt', STATUS = 'OLD')
        READ (1, *)
        DO WHILE (.NOT. EOF(1))
            READ (1, *) cell, yr, swdist, swidx, totacs, SWac
            SWD = 0.
            SWDcell = 0.
            
            DO j = 1, ncrops - 2
                IF (SWac(j) .GT. 0.) THEN
                    NIR = MAX(NIRCS(cell, j, 1 : 12), 0.)
                    
                    DO i = 1, 12
                        IF (distwt(swidx, i) .GT. 0.) THEN
                            Isaac(i) = (NIR(i) * ADJnir(Coefz(cell), j, soil(cell)) / (12 * AEsw(Coefz(cell))) * SWac(j) * (1 + LatLoss(swidx)))
                            wt(i) = (NIR(i) * ADJnir(Coefz(cell), j, soil(cell)) / (12 * AEsw(Coefz(cell))) * SWac(j) * (1 + LatLoss(swidx))) / distwt(swidx, i)
                        ELSE
                            Isaac(i) = (NIR(i) * ADJnir(Coefz(cell), j, soil(cell)) / (12 * AEsw(Coefz(cell))) * SWac(j) * (1 + LatLoss(swidx)))
                            wt(i) = 0.
                        END IF    
                    END DO
                    
                    
                    SWD(j, :) = SWDsup(iyear, swidx, :) * wt
                    SWDa = SUM(SWD(j, :))
                    SWDcell = SWDcell + SWD(j, :)
                    WRITE (20, 201) cell, iyear, swdist, swidx, Coefz(cell), j, soil(cell), SWac(j), Dummy, Precip(cell, 0), &
                                    SWDa / (1 + LatLoss(swidx)) * 12 / SWac(j), SWDa / (1 + LatLoss(swidx)), LatLoss(swidx), SWDa, Dummy
                    
                    jj = jj + 1
                    WRITE (11, 111) jj, cell, iyear, swdist, swidx, j, SWDa, SWD(j, :)
                END IF
            END DO
            
            SWDa = SUM(SWDcell(1 : 12))
            AnnID(pflag - 1) = AnnID(pflag - 1) + SWDa
        END DO
        CLOSE (1)
        CLOSE (11)
        
        kk = 0
        pflag = 4
        !Co-mingled Loop
        OPEN (1, FILE = TRIM(LUDIR)//TRIM(COLUfld)//'\'//TRIM(COLU)//TRIM(YRTlu)//'.txt', STATUS = 'OLD')
        READ (1, *)
        DO WHILE (.NOT. EOF(1))
            READ (1, *) cell, yr, swdist, swidx, totacs, COac
            COP1 = 0.
            COP2 = 0.
            COPcell = 0.
            COD = 0.
            CODcell = 0.
            
            DO j = 1, ncrops - 2
                IF (COac(j) .GT. 0.) THEN
                    NIR = MAX(NIRCS(cell, j, 1 : 12), 0.)
                    
                    DO i = 1, 12
                        IF (distwt(swidx, i) .GT. 0.) THEN
                            Isaac(i) = (NIR(i) * ADJnir(Coefz(cell), j, soil(cell)) / (12 * AEsw(Coefz(cell))) * COac(j) * (1 - GWC(swidx)) * (1 + LatLoss(swidx))) 
                            wt(i) = (NIR(i) * ADJnir(Coefz(cell), j, soil(cell)) / (12 * AEsw(Coefz(cell))) * COac(j) * (1 - GWC(swidx)) * (1 + LatLoss(swidx))) / distwt(swidx, i)
                        ELSE
                            Isaac(i) = (NIR(i) * ADJnir(Coefz(cell), j, soil(cell)) / (12 * AEsw(Coefz(cell))) * COac(j) * (1 - GWC(swidx)) * (1 + LatLoss(swidx)))
                            wt(i) = 0.
                        END IF
                    END DO
                    
                    
                    COD(j, :) = SWDsup(iyear, swidx, :) * wt
                    CODa = SUM(COD(j, :))
                    CODcell = CODcell + COD(j, :)
                    
                    IF (GWC(swidx) .EQ. 1.0) THEN
                        CODnet = 0.
                        COP1(j, :) = 0.
                    ELSE    
                        CODnet = COD(j, :) / (1 + LatLoss(swidx)) * 12 / (COac(j) * (1 - GWC(swidx))) * AEsw(coefz(cell))
                        COP1(j, :) = (NIR(1 : 12) * ADJnir(Coefz(cell), j, soil(cell)) - CODnet) / (12 * AEgw(Coefz(cell))) * COac(j) * (1 - GWC(swidx))  !1-13-2015 removed second ADJnir(*) after 'CODne)'
                    END IF
                    
                    DO i = 1, 12
                        IF (COP1(j, i) .LT. 0.01) COP1(j, i) = 0.
                    END DO
                    
                    COP2(j, :) = NIR * ADJnir(Coefz(cell), j, soil(cell)) / (12 * AEgw(Coefz(cell))) * COac(j) * GWC(swidx)
                    
                    COPa = SUM(COP1(j, :)) + SUM(COP2(j, :))
                    COPcell = COPcell + COP1(j, :) + COP2(j, :)
                    
                    IF (GWC(swidx) .NE. 1.) THEN
                        value1 = CODa / (1 + LatLoss(swidx)) * 12 / (COac(j) * (1 - GWC(swidx)))
                    ELSE
                        value1 = 0.
                    END IF
                    
                    WRITE (20, 201) cell, iyear, swdist, swidx, Coefz(cell), j, soil(cell), Dummy, CoAc(j), Precip(cell, 0), &
                                    value1, CODa / (1 + LatLoss(swidx)), LatLoss(swidx), CODa, GWC(swidx)
                    
                    kk = kk + 1
                    WRITE (12, 111) kk, cell, iyear, swdist, swidx, j, CODa, COD(j, :)
                    WRITE (13, 111) kk, cell, iyear, swdist, swidx, j, COPa, COP1(j, :) + COP2(j, :)
                    
                END IF
            END DO
            
            COPa = SUM(COPcell)
            CODa = SUM(CODcell)
            
            AnnID(pflag - 1) = AnnID(pflag - 1) + COPa
            AnnID(pflag) = AnnID(pflag) + CODa
            
        END DO
        
        CLOSE (1)
        CLOSE (12)
        CLOSE (13)
        CLOSE (20)
        
        WRITE (30, 301) iyear, ii, jj, kk
        WRITE (40, 401) iyear, AnnID
        
    END DO
    
    CLOSE (30)
    CLOSE (40)
    
100 FORMAT ('Index, Cell, Year, crop', 13(', GWP_', A3))
101 FORMAT ('Index, Cell, Year, District, SW_index, Crop', 13(', SWD_', A3))
102 FORMAT ('Index, Cell, Year, District, SW_index, Crop', 13(', COP_', A3))
103 FORMAT ('Index, Cell, Year, District, SW_index, Crop', 13(', COD_', A3))    
    
110 FORMAT (2(I7, ','), I5, ',', I4, 13(',', F14.7))
111 FORMAT (2(I7, ','), I5, 3(',', I4), 13(',', F14.7))
        
200 FORMAT ('Cell, CalcYr, CanalDistrict, Canaldistrictindex, Zone, Crop, Soil, SWOnlyAcres, CommingledAcres, Precip, ' &
            'CropDemand_in, CropDemand_AF, LateralLossPercent, DivDemand_AF, GWC')
201 FORMAT (I7, ',', I5, 5(',', I4), 5(',', F8.2), ',', F5.2, ',', F8.2, ',', F5.2)
    
300 FORMAT ('Year, GWtrans, SWtrans, COtrans')
301 FORMAT (I5, 3(',', I7))
    
400 FORMAT ('Year, GWP, SWD, COP, COD')
401 FORMAT (I5, 4(',', F14.2))
    
!Added 1/7/2016
600 FORMAT (' Sim Year,  LU Year, WBP Year, GWC Year')
601 FORMAT (I9, 3(',', I9))
    
END PROGRAM Irr_Supply
!****************************************************************************
SUBROUTINE CSFiles
    USE PARAM
    IMPLICIT NONE
    
    !Variables
    INTEGER     nn, crp
    
    NIRCS = 0.

    DO nn = 1, ncrops - 2
        OPEN (100, FILE = TRIM(WBPDIR)//'NIR\'//Trim(Crops(nn))//'-NIR'//TRIM(YRTwbp)//'.txt', STATUS = 'OLD')
        READ (100, *)
        DO WHILE (.NOT. EOF(100)) 
            READ (100, *) cell, yr, crp, (NIRCS(cell, nn, i), i = 0, 12)
        END DO
        CLOSE (1)
    END DO
    
END SUBROUTINE CSFiles
!****************************************************************************
SUBROUTINE GetAE
    USE PARAM

    !Variables
    INTEGER izone
    
    DO izone = 1, nczones
        IF (iyear .LE. AEgyr(izone, 1)) THEN
            AEgw(izone) = AEgwb(izone, 1)
        ELSE IF (iyear .GE. AEgyr(izone, 2)) THEN
            AEgw(izone) = AEgwb(izone, 2)
        ELSE
            AEgw(izone) = AEgwb(izone, 1) + (AEgwb(izone, 2) - AEgwb(izone, 1)) * ((iyear - AEgyr(izone, 1)) / (AEgyr(izone, 2) - AEgyr(izone, 1)))
        END IF
    
        IF (iyear .LE. AEsyr(izone, 1)) THEN
            AEsw(izone) = AEswb(izone, 1)
        ELSE IF (iyear .GE. AEsyr(izone, 2)) THEN
            AEsw(izone) = AEswb(izone, 2)
        ELSE
            AEsw(izone) = AEswb(izone, 1) + (AEswb(izone, 2) - AEswb(izone, 1)) * ((iyear - AEsyr(izone, 1)) / (AEsyr(izone, 2) - AEsyr(izone, 1)))
        END IF
    END DO
    
END SUBROUTINE GetAE
!****************************************************************************